// MyLiftClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyLiftClient.h"
#include "MyLiftClientDlg.h"
#include "ConnectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

inline int pow2(int n) { return n*n; }

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyLiftClientDlg dialog

CMyLiftClientDlg::CMyLiftClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyLiftClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyLiftClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_prikazyZVytahu = NULL;
	m_curLevel = NULL;
	m_curSmery = NULL;
	m_bOpenStatus = false;
}
CMyLiftClientDlg::~CMyLiftClientDlg()
{
	delete [] m_prikazyZVytahu;
	delete [] m_curLevel;
	delete [] m_curSmery;
}

void CMyLiftClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyLiftClientDlg)
	DDX_Control(pDX, IDC_COMMANDS, m_boxCommands);
	DDX_Control(pDX, IDC_EVENTS, m_boxEvents);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyLiftClientDlg, CDialog)
	//{{AFX_MSG_MAP(CMyLiftClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WS_EVENT_MSG, OnNetEvent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyLiftClientDlg message handlers

BOOL CMyLiftClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CConnectDlg cnx;
	if(cnx.DoModal() != IDOK)
	{
		AfxPostQuitMessage(0);
		return 0;
	}

	try
	{
		m_socket.Create();
		m_socket.Connect(cnx.m_strHostname, cnx.m_nPort);
		WSAAsyncSelect(m_socket, m_hWnd, WS_EVENT_MSG, FD_READ);
		m_socket.Write("param\r\n", 7);

	}
	catch(const SocketException& e)
	{
		CString err;
		err.Format("Unable to connect (%d) !", e.err);
		AfxMessageBox(err);
		AfxPostQuitMessage(0);
		return 0;
	}

	//AfxMessageBox("Connected!", MB_ICONINFORMATION);
	AfxBeginThread(DoorOpener, this, THREAD_PRIORITY_NORMAL);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMyLiftClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyLiftClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyLiftClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CMyLiftClientDlg::OnNetEvent(WPARAM,LPARAM)
{
	while(1)
	{
		CString line = m_socket.ReadLine();
		if(line.IsEmpty())
			break;
		
		m_boxEvents.AddString(line);
		
		ProcessEvent(line);

		Think();
	}
	return 0;
}

void CMyLiftClientDlg::Think()
{
	const int m = m_nLevels * m_nLevels;

	for(int i=0;i<m_nShafts;i++)
	{
		CString cmd;
		int up = 0, down = 0;int j;
		// obodovat smery

		// neceka se na otevreni
		for(int x=0;x<m_arrOpenWaits.GetSize();x++)
		{
			if(m_arrOpenWaits[x] == i)
				goto konec_cyklu_shafts; // Java to umi lip
		}

		for(j=0;j<m_prikazyZVytahu[i].GetSize();j++)
		{
			if(m_prikazyZVytahu[i][j] > m_curLevel[i]) // je vys
				up += m / pow2(m_prikazyZVytahu[i][j] - m_curLevel[i]);
			else if(m_prikazyZVytahu[i][j] < m_curLevel[i]) // je niz
				down += m / pow2(m_curLevel[i] - m_prikazyZVytahu[i][j]);
			else // jsme v patre
			{

				// odstranit vsechny prikazy na toto patro
				for(int x=0;x<m_prikazyZVytahu[i].GetSize();x++)
				{
					if(m_prikazyZVytahu[i][x] == m_curLevel[i])
					{
						m_prikazyZVytahu[i].RemoveAt(x);
						if(x <= j)
							j--;
					}
				}
				// otevrit dvere
				m_arrOpenWaits.Add(i);
				goto konec_cyklu_shafts; // Java to umi lip
			}
		}

		// mame to obodovane, ted odecist "cenu za zmenu smeru"
		if(m_curSmery[i] == 0)
			;
		else if(m_curSmery[i] == 1) // nahoru
			down -= m / 5;
		else if(m_curSmery[i] == 2) // dolu
			up -= m / 5;

		if(up == 0 && down == 0)
		{
			// neni kam jet
			cmd.Format("speed %d 0\r\n", i);
		}
		else if(up >= down)
		{
			// rozjet vytah nahoru
			cmd.Format("speed %d -%d\r\n", i, m_nLevelHeight/2);
			CString info;
			info.Format("Rozjizdim vytah #%d nahoru", i);
			
			m_boxCommands.InsertString(m_boxCommands.GetCount(),info);
		}
		else if(down = up)
		{
			// rozjet vytah dolu
			cmd.Format("speed %d %d\r\n", i, m_nLevelHeight/2);
			CString info;
			info.Format("Rozjizdim vytah #%d dolu", i);
			
			m_boxCommands.InsertString(m_boxCommands.GetCount(),info);
		}

		m_socket.Write(cmd, cmd.GetLength());
		

konec_cyklu_shafts:;
	}
}

void CMyLiftClientDlg::ProcessEvent(CString line)
{
	if(strncmp(line, "shafts", 6) == 0)
	{
		delete [] m_prikazyZVytahu;
		delete [] m_curLevel;
		delete [] m_curSmery;
		for(int i=0;i<m_arrOpenWaits.GetSize();i++)
			KillTimer(m_arrOpenWaits[i]);
		m_arrOpenWaits.RemoveAll();

		m_nShafts = atoi(((LPCTSTR) line) + 7);
		m_prikazyZVytahu = new CUIntArray[m_nShafts];
		m_curLevel = new int[m_nShafts];
		m_curSmery = new int[m_nShafts];
		memset(m_curLevel, 0, m_nShafts * 4);
		// 0 - nikam
		// 1 - nahoru
		// 2 - dolu
		memset(m_curSmery, 0, m_nShafts * 4);
	}
	else if(strncmp(line, "levels ", 7) == 0)
	{
		m_nLevels = atoi( ((LPCTSTR) line) + 7);
	}
	else if(strncmp(line, "cabinbutton", 11) == 0)
	{
		int shaft, to;
		sscanf(line, "cabinbutton %d %d", &shaft, &to);

		m_prikazyZVytahu[shaft].InsertAt(0,to);

		while(m_bOpenStatus)
				Sleep(50);
		Think();
	}
	else if(strncmp(line, "levelheight", 11) == 0)
	{
		m_nLevelHeight = atoi(((LPCTSTR)line) + 12);
	}
	else if(strncmp(line, "level ", 6) == 0)
	{
		int level, shaft, oldlvl;
		CString ind;
		sscanf(line, "level %d %d", &shaft, &level);

		oldlvl = m_curLevel[shaft];
		this->m_curLevel[shaft] = level;

		// zhasnout a rozsvitit diody
		ind.Format("indion %d %d\r\n", shaft, level);
		m_socket.Write(ind,ind.GetLength());
		ind.Format("indioff %d %d\r\n", shaft, oldlvl);
		m_socket.Write(ind,ind.GetLength());
		ind.Format("indiupoff %d\r\n", level);
		m_socket.Write(ind,ind.GetLength());
		ind.Format("indidnoff %d\r\n", level);
		m_socket.Write(ind,ind.GetLength());
	}
	else if(strncmp(line, "maxaccel", 8) == 0)
	{
		m_nAccel = atoi( ((LPCTSTR) line) + 9);
	}
	else if(strncmp(line, "opened", 6) == 0)
	{
		m_bOpenStatus = true;
	}
	else if(strncmp(line, "closed", 6) == 0)
	{
		m_bOpenStatus = false;
	}
	else if(strncmp(line, "levelbuttondn", 13) == 0)
	{
		int patro = atoi( ((LPCTSTR) line) + 14);
		// rosvitime mu
		CString cmd;
		cmd.Format("indidnon %d\r\n", patro);
		m_socket.Write(cmd, cmd.GetLength());
		// prikaz jako by do daneho patra nekdo jel

		// najit nejblizsi vytah
		int nejbliz = 0;
		for(int i=0;i<m_nLevels;i++)
		{
			if(abs(m_curLevel[i] - patro) < m_curLevel[nejbliz])
				nejbliz = i;
		}
		m_prikazyZVytahu[nejbliz].Add(patro);

		while(m_bOpenStatus)
			Sleep(50);
	}
	else if(strncmp(line, "levelbuttonup", 13) == 0)
	{
		int patro = atoi( ((LPCTSTR) line) + 14);
		// rosvitime mu
		CString cmd;
		cmd.Format("indiupon %d\r\n", patro);
		m_socket.Write(cmd, cmd.GetLength());

		// prikaz jako by do daneho patra nekdo jel

		// najit nejblizsi vytah
		int nejbliz = 0;
		for(int i=0;i<m_nLevels;i++)
		{
			if(abs(m_curLevel[i] - patro) < m_curLevel[nejbliz])
				nejbliz = i;
		}
		m_prikazyZVytahu[nejbliz].Add(patro);

		while(m_bOpenStatus)
			Sleep(50);
	}
}

void CMyLiftClientDlg::WaitForEvent(CString name)
{
	while(1)
	{
		CString line = m_socket.ReadLine();
		if(line.IsEmpty())
			Sleep(250);
		else
		{
			if(strncmp(line, name, name.GetLength()) == 0)
				break;
			else
				ProcessEvent(line);
		}
	}
}

UINT CMyLiftClientDlg::DoorOpener(void* p)
{
	CMyLiftClientDlg* This = (CMyLiftClientDlg*) p;
	while(1)
	{
		while(This->m_arrOpenWaits.GetSize())
		{
			CString cmd;
			cmd.Format("Zastavuji vytah #%d", This->m_arrOpenWaits[0]);
			This->m_boxCommands.InsertString(This->m_boxCommands.GetCount(),cmd);
			cmd.Format("speed %d 0\r\n", This->m_arrOpenWaits[0]);
			This->m_socket.Write(cmd, cmd.GetLength());

			// pockat nez zastavi
			Sleep(double(This->m_nLevelHeight) / double(This->m_nAccel) * 1000);

			cmd.Format("Oteviram dvere u vytahu #%d", This->m_arrOpenWaits[0]);
			This->m_boxCommands.InsertString(This->m_boxCommands.GetCount(),cmd);
			cmd.Format("open %d\r\n", This->m_arrOpenWaits[0]);
			This->m_socket.Write(cmd, cmd.GetLength());
			
			This->m_bOpenStatus = false;
			while(!This->m_bOpenStatus)
				Sleep(50);

			Sleep(3000); // jen at vyleze

			// zavrit dvere

			cmd.Format("Zaviram dvere u vytahu #%d", This->m_arrOpenWaits[0]);
			This->m_boxCommands.InsertString(This->m_boxCommands.GetCount(),cmd);
			cmd.Format("close %d\r\n", This->m_arrOpenWaits[0]);
			This->m_socket.Write(cmd, cmd.GetLength());
			//m_boxCommands.AddString(cmd);
			// pockat na zavreni
			while(This->m_bOpenStatus)
				Sleep(50);

			This->m_arrOpenWaits.RemoveAt(0);
		}
		Sleep(100); // nevarit CPU
	}
}